#!/usr/bin/perl
use Mail::Box::Manager;
use Mail::Message;
use Mail::Transport::SMTP;
use Getopt::Std;

getopts("l:");
	$list = $opt_l;

if(!($list)){
	print "Please specify the name of the mail list (on lists.abc.org).\n USAGE: ./check_mail_list.pl -l <LISTNAME>\n";
	exit 3;
}

my $mgr = Mail::Box::Manager->new;
my $smtp;
my $newmsg;
my $returnstring;
my $status = 0;
my $count = 0;
###################Set up the Mail Box#################################
local $SIG{ALRM} = sub { print "WARNING: Time-out while connecting to POP server
\n"; exit 1; };
alarm(10);
$folder = $mgr->open( type => 'pop3',
                      username => 'USERNAME',
                      password => 'PASSWORD',
                      server_name => 'POPSERVER',
                      server_port => '110',
                      );
alarm(0);                                                     
if (!$folder){                                                
        print "Cant connect to folder\n";
        exit(2);                                              
}


##################Set up SMTP connection###############################
$smtp = Mail::Transport::SMTP->new(
	via => 'smtp',
	hostname => 'SMTPSERVER'
);

#################Check to see if our last email was recieved###########
foreach my $msg ($folder->messages){
	if ($msg->subject =~ /LISTSERV/){
		$count++;
		$msg->delete;
	}
}
if($count > 0){
	$returnstring = "OK: One or more LISTSERV  mail messages found\n";
	$status = 0;
}else{
	$returnstring = "CRITICAL: No LISTSERV  mail messages found\n";
	$status = 2;
}

################Build new message######################################
$newmsg = Mail::Message->build(
	From => 'nagios@NAGIOS SERVER',
	To => $list . '@lists.abc.org',
	Subject => 'This is a LISTSERV mail  - ' . localtime(),
	data => localtime() . '-This is a LISTSERV  email which is meant to test lists.abc.org. If this does not get through there is a problem.' 
);

#################Send New Message#########################################
$smtp->send($newmsg);


print $returnstring;
exit $status;
